library(ggplot2)
library(ncdf4)
library(trend)
library(loadeR)
library(transformeR)
library(visualizeR)
library(RColorBrewer)

rm(list=ls()) ; gc()

#Pregunta:
#LLEVARLOS TODOS A UNA RETICULA COMÚN Y LUEGO CALCULAR LA TENDENCIA? O AL REVÉS?
#VER TRABAJOS DEL ESTILO COPPOLA ET AL. 2021

#Working directory
dir <- "~/Downloads/CLIMCAT/CMIP6/"
OUTPUTS <- "~/Downloads/CLIMCAT/"
setwd(dir)

#-------Annual indices---------#
#Useful information
indices <- c("wsdi","csdi","tr",
            "r20mm","prcptot","cdd","cwd")
files <- intersect(list.files(pattern="2014.nc"),list.files(pattern="yr"))
ssn <- "Annual"
seasons <- list(c(1:12))
Model <- NA

trend.indices <- list()
series.indices <- list()

for(i in 1:length(indices)){
  print(indices[i])
  files_subset <- intersect(files,list.files(pattern=indices[i]))
  trend.indices[[i]] <- list()
  series.indices[[i]] <- list()
  
  for(m in 1:length(files_subset)){
    print(files_subset[m])
    
    trend.indices[[i]][[m]] <- list()
    series.indices[[i]][[m]] <- list()
    
    for(s in 1:length(seasons)){
      di <- dataInventory(files_subset[m])
      
      ini <- nchar(names(di))                            
      out <- nchar("_historical_r4i1p1f1_1950-2014.nc_interp.nc")
      Model[m] <- substr(files_subset[m],start=ini+5,stop=nchar(files_subset[m])-out)
      
      data <- loadGridData(files_subset[m],var=names(di),)
      
      trends <- matrix(NA,length(data$xyCoords$y),length(data$xyCoords$x))
      signif <- matrix(NA,dim(trends)[1],dim(trends)[2])
      
      for(j in 1:dim(trends)[1]){
        for(k in 1:dim(trends)[2]){
          if(!is.na(mean(data$Data[,j,k],na.rm=T))){
            trends[j,k] <- lm(data$Data[,j,k]~c(1:length(unique(getYearsAsINDEX(data)))))[["coefficients"]][2]
            signif[j,k] <- mk.test(na.omit(data$Data[,j,k]),continuity = T)$p.value
          }
        }
      }
      
      datita <- data.frame(Trend=as.numeric(trends),
                           Significance=as.numeric(signif),
                           Season=rep(ssn[s],length(as.numeric(trends))),
                           Model=rep(Model[m],length(as.numeric(trends))),
                           Longitude=rep(data$xyCoords$x,each=length(data$xyCoords$y)),
                           Latitude=rep(data$xyCoords$y,length(data$xyCoords$x)),
                           Index=rep(indices[i],length(as.numeric(trends))))
      
      
      trend.indices[[i]][[m]][[s]] <- datita #tal vez acá va el data.frame
      series.indices[[i]][[m]][[s]] <- data
      gc()
      
      if(indices[i]%in%c("cdd")){paleta=rev(brewer.pal(11,"BrBG"))}
      if(indices[i]%in%c("cwd","prcptot","r20mm")){paleta=brewer.pal(11,"BrBG")}
      if(indices[i]%in%c("wsdi","tr")){paleta=rev(brewer.pal(11,"RdBu"))}
      if(indices[i]%in%c("csdi")){paleta=brewer.pal(11,"RdBu")}
      
      png(filename = paste(OUTPUTS,"Trend_",ssn[s],indices[i],Model[m],".png",sep=""),res=600,width=3000,height=2000)
      print(ggplot(data=datita,aes(x=Longitude,y=Latitude,fill=Trend)) + geom_tile()  +  
              scale_fill_gradientn(name=paste(di[[names(di)]][["Units"]],"decade",sep="/"),colours=paleta,limits=c(-0.3,0.3),na.value = "white")+
              coord_quickmap(xlim=c(min(datita$Longitude),max(datita$Longitude)),
                             ylim=c(min(datita$Latitude),max(datita$Latitude)),expand=F)+ borders() + 
              theme_bw() + ggtitle(paste(ssn[s],indices[i],Model[m],sep=" "))+geom_text(data=subset(datita,Significance<=0.05),aes(label="*",fontface="bold")))
      dev.off() 
    }
  }
}
save(trend.indices,file="trend.indices.yr.CMIP6.historical.Rdata")
save(series.indices,file="series.indices.yr.CMIP6.historical.Rdata")

#--------Seasonal indices--------------------#
files <- intersect(list.files(pattern="201412.nc"),list.files(pattern=""))
seasons <- list(c(12,1,2),c(3,4,5),c(6,7,8),c(9,10,11)) #DJF #MAM #JJA #SON #ANNUAL
ssn <- c("Winter","Spring","Summer","Autumn")#,"Annual")
indices <- c("txx","txn","tnx","tnn","tx90p","tx10p","tn90p","tn10p",
             "rx5day","rx1day")
Model <- NA

trend.indices <- list()
series.indices <- list()

for(i in 1:length(indices)){
  print(indices[i])
  files_subset <- intersect(files,list.files(pattern=indices[i]))
  trend.indices[[i]] <- list()
  series.indices[[i]] <- list()
  
  for(m in 1:length(files_subset)){
    print(files_subset[m])
  
    trend.indices[[i]][[m]] <- list()
    series.indices[[i]][[m]] <- list()
    
    for(s in 1:length(seasons)){
      di <- dataInventory(files_subset[m])
      
      ini <- nchar(names(di))                            
      out <- nchar("_historical_r4i1p1f1_195001-201412.nc_interp.nc")
      Model[m] <- substr(files_subset[m],start=ini+6,stop=nchar(files_subset[m])-out)
      
      data <- loadGridData(files_subset[m],var=names(di),)
      data <- aggregateGrid(data,aggr.s = list(FUN=list("mean",na.rm=T),season=seasons[[s]]))
      
      trends <- matrix(NA,length(data$xyCoords$y),length(data$xyCoords$x))
      signif <- matrix(NA,dim(trends)[1],dim(trends)[2])
      
      for(j in 1:dim(trends)[1]){
        for(k in 1:dim(trends)[2]){
          if(!is.na(mean(data$Data[,j,k],na.rm=T))){
          trends[j,k] <- lm(data$Data[,j,k]~c(1:length(unique(getYearsAsINDEX(data)))))[["coefficients"]][2]
          signif[j,k] <- mk.test(data$Data[,j,k],continuity = T)$p.value
          }
        }
      }
      
      datita <- data.frame(Trend=as.numeric(trends),
                           Significance=as.numeric(signif),
                           Season=rep(ssn[s],length(as.numeric(trends))),
                           Model=rep(Model[m],length(as.numeric(trends))),
                           Longitude=rep(data$xyCoords$x,each=length(data$xyCoords$y)),
                           Latitude=rep(data$xyCoords$y,length(data$xyCoords$x)),
                           Index=rep(indices[i],length(as.numeric(trends))))
      
      trend.indices[[i]][[m]][[s]] <- datita #tal vez acá va el data.frame
      series.indices[[i]][[m]][[s]] <- data
      gc()
    
      if(di[[names(di)]][["Units"]]%in%c("mm")){paleta=brewer.pal(11,"BrBG")}
      if(di[[names(di)]][["Units"]]%in%c("degrees_C","days","%")){paleta=rev(brewer.pal(11,"RdBu"))}
      
      png(filename = paste(OUTPUTS,"Trend_",ssn[s],indices[i],Model[m],".png",sep=""),res=600,width=3000,height=2000)
      print(ggplot(data=datita,aes(x=Longitude,y=Latitude,fill=Trend)) + geom_tile()  +  
        scale_fill_gradientn(name=paste(di[[names(di)]][["Units"]],"decade",sep="/"),colours=paleta,limits=c(-0.3,0.3),na.value = "white")+
        coord_quickmap(xlim=c(min(datita$Longitude),max(datita$Longitude)),
                       ylim=c(min(datita$Latitude),max(datita$Latitude)),expand=F)+ borders() + 
        theme_bw() + ggtitle(paste(ssn[s],indices[i],Model[m],sep=" "))+geom_text(data=subset(datita,Significance<=0.05),aes(label="*",fontface="bold")))
     dev.off() 
    }
  }
}
#paste(ssn[s],indices[i],Model[m]
save(trend.indices,file="trend.indices.mon.CMIP6.historical.Rdata")
save(series.indices,file="series.indices.mon.CMIP6.historical.Rdata")

#--------Ploteo de heatmap-------#

#Annual
test <- list()
for(i in 1:length(indices)){
  test[[i]] <- list()
  for(m in 1:length(files_subset)){
    test[[i]][[m]] <- do.call("rbind",trend.indices[[i]][[m]])
  }
}

test2 <- list()
for(i in 1:length(indices)){
     test2[[i]] <- do.call("rbind",test[[i]])
}

test3 <- do.call("rbind",test2)
trend <- aggregate(Trend~Model+Index,test3,FUN="mean",na.rm=T)

ggplot(data=trend,aes(x=Index,y=Model,fill=Trend)) + theme_bw() + geom_tile() +
  scale_color_gradientn("Trend",colours = rev(brewer.pal(n=11,name="RdYlBu")),limits=c(-0.8,0.8),
                        aesthetics = "fill",na.value = "white") + ggtitle(ssn[s])

#---------------------------#
#Seasonal
load("trend.indices.mon.CMIP6.historical.Rdata")
test <- list()
for(i in 1:length(indices)){
  test[[i]] <- list()
  for(m in 1:length(files_subset)){
    test[[i]][[m]] <- do.call("rbind",trend.indices[[i]][[m]])
  }
}

test2 <- list()
for(i in 1:length(indices)){
  test2[[i]] <- do.call("rbind",test[[i]])
}

test3 <- do.call("rbind",test2)
trend <- aggregate(Trend~Model+Index+Season,test3,FUN="mean",na.rm=T)
sign <- aggregate(Significance~Model+Index+Season,test3,FUN="median",na.rm=T)

trend$Significance <- sign$Significance
trend$Model[which(trend$Model=="")] <- "ERA5"
trend$Model <- factor(trend$Model,levels=c("ERA5",unique(trend$Model)[-which(unique(trend$Model=="ERA5"))]))
ggplot(data=trend,aes(x=Index,y=Model,fill=Trend)) + theme_bw() + geom_tile() + facet_wrap(~Season)+
  scale_color_gradientn("Trend",colours = rev(brewer.pal(n=11,name="RdYlBu")),limits=c(-0.25,0.25),
                        aesthetics = "fill",na.value = "white") + ggtitle("Seasonal") +
  geom_text(data=subset(trend,Significance<=0.05),aes(x=Index,y=Model,label="*",fontface="bold"))

#-------------------------#
#Subset Catalunya
trend.indices2 <- subset(test3,Latitude>40 & Latitude<43 & Longitude<3 & Longitude>0)

trend <- aggregate(Trend~Model+Index+Season,trend.indices2,FUN="mean",na.rm=T)
sign <- aggregate(Significance~Model+Index+Season,test3,FUN="median",na.rm=T)

trend$Significance <- sign$Significance
trend$Model[which(trend$Model=="")] <- "ERA5"
trend$Model <- factor(trend$Model,levels=c("ERA5",unique(trend$Model)[-which(unique(trend$Model=="ERA5"))]))
ggplot(data=trend,aes(x=Index,y=Model,fill=Trend)) + theme_bw() + geom_tile() + facet_wrap(~Season)+
  scale_color_gradientn("Trend",colours = rev(brewer.pal(n=11,name="RdYlBu")),limits=c(-0.25,0.25),
                        aesthetics = "fill",na.value = "white") + ggtitle("Seasonal Catalonia") +
  geom_text(data=subset(trend,Significance<=0.05),aes(x=Index,y=Model,label="*",fontface="bold"))
